From d1ced5f00c7c3746dd75ef992bd726aed84c5f12 Mon Sep 17 00:00:00 2001
From: Eric Barbour <ebarbour@redhat.com>
Date: Aug 10 2016 19:35:20 +0000
Subject: [PATCH 15/16] Modify stream.py to fake JSON messages


- Since the Flock demo is done, it decreases complexity to pass JSON
objects until stream functionality can be added in fmn.

---

diff --git a/hubs/app.py b/hubs/app.py
index ff9cb3a..43f32a6 100755
--- a/hubs/app.py
+++ b/hubs/app.py
@@ -523,17 +523,9 @@ def stream(name):
     saved = hubs.models.SavedNotification.by_username(session, name)
     saved = [n.__json__() for n in saved]
 
-    stream = hubs.stream.Stream(name)
-    actions = stream.get_actions()
+    stream = hubs.stream.Stream()
+    actions = stream.get_json()
 
-    # An action that has already been saved should not have a saved button
-    # this tags all the saved actions so the front end can decide to display or not.
-    # This will get slow pretty quickly so we should reevaluate after flock
-    for action in actions:
-        if any(s['markup'] == action['markup'] for s in saved):
-            action['saved'] = True
-
-    actions = json.dumps(actions, cls=hubs.stream.PythonObjectEncoder)
     return flask.render_template(
         'stream.html',
         hub=hub,
diff --git a/hubs/stream.py b/hubs/stream.py
index 8c33bf2..fd45923 100644
--- a/hubs/stream.py
+++ b/hubs/stream.py
@@ -1,166 +1,9 @@
-import cgi
-import datetime
 import json
-import uuid
+import os
 
-import datanommer.models
-import flask
-import fmn.lib
-import munch
-import pygments.formatters
-import six
-
-import fedmsg.config
-import fedmsg.meta
-
-
-# TODO Temporary: This is a proof of concept for Flock
-# This needs to be done in fnm.lib
 class Stream(object):
-    paths = fmn.lib.load_rules(root='fmn.rules')
-    fedmsg_config = fedmsg.config.load_config()
-    delta = datetime.timedelta(days=365)
-    end = datetime.datetime.utcnow()
-
-    def __init__(self, name):
-        self.name = name
-        self.preference = {
-            'filters': [{
-                'created_on': 'Thu, 15 Jan 2015 16:07:43 GMT',
-                'id': 20506,
-                'name': 'Events referring to my username',
-                'oneshot': None,
-                'rules': [
-                    {
-                        'arguments': {
-                            'fasnick': name
-                        },
-                        'cache_key':
-                        '2f59dcddf85cab5822af8d40d82c7390ce0f80b40119f2db67f3037a0594a2a1',
-                        'code_path': 'fmn.rules:user_filter',
-                        'created_on': 'Thu, 15 Jan 2015 16:07:43 GMT',
-                        'info': {
-                            'args': [
-                                'config', 'message', 'fasnick'
-                            ],
-                            'datanommer-hints': {},
-                            'doc':
-                            "<p>Use this rule to include messages that are associated with a\nspecific user.</p>",
-                            'doc-no-links':
-                            '<html><head></head><body><p>Use this rule to include messages that are associated with a\nspecific user.</p>\n</body></html>',
-                            'hints-invertible': True,
-                            'submodule': 'generic',
-                            'title': 'A particular user'
-                        },
-                        'negated': False
-                    }
-                ]
-            }]
-        }
-
-    def apply_html(self, matches):
-        # Smash multiple messages into single ones
-        matches = fedmsg.meta.conglomerate(matches,
-                                           lexers=True,
-                                           **self.fedmsg_config)
-
-        # Apply some html markup to the subtitles for extra fanciness.
-        for match in matches:
-            match['markup'] = self.apply_markup(match)
-            for idx, constituent in match['msg_ids'].items():
-                constituent['markup'] = self.apply_markup(constituent)
-                if constituent['long_form'] != constituent['subtitle']:
-                    if constituent.get('lexer'):
-                        constituent['long_form'] = pygments.highlight(
-                            constituent['long_form'],
-                            constituent['lexer'],
-                            pygments.formatters.HtmlFormatter(
-                                style='monokai'), )
-                    else:
-                        markup = u"<h5>{long_form}</h5>".format(**constituent)
-                        constituent['long_form'] = markup
-            # And tack on a unique identifier for each top level entry.
-            match['dom_id'] = six.text_type(uuid.uuid4())
-
-        return matches
-
-    def get_actions(self):
-        preference = self.rehydrate_preference(self.preference)
-        messages = []
-        actions = []
-
-        for fmn_filter in preference['filters']:
-            fmn_hinting = fmn.lib.hinting.gather_hinting(
-                self.fedmsg_config, fmn_filter['rules'], self.paths)
-            total, pages, rows = datanommer.models.Message.grep(
-                start=self.end - self.delta,
-                end=self.end,
-                rows_per_page=100,
-                page=1,
-                order='desc',
-                **fmn_hinting)
-            messages.extend(rows)
-
-
-        for message in messages:
-            original = message.__json__()
-            if self.name in fedmsg.meta.msg2usernames(original, **
-                                                      self.fedmsg_config):
-                actions.append(original)
-
-        return self.apply_html(actions)
-
-    def rehydrate_preference(self, preference):
-        for fltr in preference['filters']:
-            fltr['rules'] = [munch.Munch(r) for r in fltr['rules']]
-            for rule in fltr['rules']:
-                code_path = str(rule.code_path)
-                rule.fn = fedmsg.utils.load_class(code_path)
-
-        return preference
-
-    def escape_html(self, match):
-        for key in ['subjective', 'subtitle']:
-            match[key] = cgi.escape(match[key])
-        try:
-            match['long_form'] = cgi.escape(match['long_form'])
-        except:
-            # not all matches have a long form
-            pass
-        return match
-
-    def apply_markup(self, match):
-        match = self.escape_html(match)
-        markup = match['subtitle']
-        for username in match['usernames']:
-            args = (username, '<a href="{url}" rel="nofollow">@{username}</a>'.format(
-                url=flask.url_for('hub', name=username),
-                username=username, ))
-            markup = markup.replace(*args)
-            # TODO -- have to add these to conglomerate first
-            # match['long_form'] = match['long_form'].replace(*args)
-
-        for package in match['packages']:
-            args = (package, '<a href="{url}">{package}</a>'.format(
-                url='https://apps.fedoraproject.org/packages/' + package,
-                package=package, ))
-            markup = markup.replace(*args)
-            # TODO -- have to add these to conglomerate first
-            # match['long_form'] = match['long_form'].replace(*args)
-
-        return markup
-
-
-class PythonObjectEncoder(json.JSONEncoder):
-    ''' A JSON encoder that handles python data structures in encoding'''
-
-    def default(self, obj):
-        if isinstance(obj, (list, dict, str, unicode, int, float, bool,
-                            type(None))):
-            return json.JSONEncoder.default(self, obj)
-        if isinstance(obj, set) or isinstance(obj, tuple):
-            return list(obj)
-        if isinstance(obj, object):
-            return obj.__dict__
-        else:
-            raise TypeError
+    def get_json(self):
+        here = os.path.dirname(os.path.abspath(__file__))
+        with open(os.path.join(here, 'actions.json')) as fp:
+            actions = fp.read()
+        return actions
